"""Really evil stuff.
"""
__version__ = '$Revision: 1.4 $'
#  $Source: /projects/cvsroot/koe/docs/support/htmltags.py,v $

import grailutil
import string

ATTRIBUTES_AS_KEYWORDS = 1


# This is VILE Hackery(tm), so don't use it unless you're me.  ;-)
DOT_PITCH = 6.5
DOT_POSTSCRIPT = "gsave (.) S grestore %s 0 R\n" % DOT_PITCH
DOT_VACANCY = 30.0


def postscript_do_pageno(self, attrs):
    """Magic to implement the <PAGENO> element used in the KOE documentation's
    Table of Contents.  It has limited general use since there's no way for
    the lookup mechanism to support forward references.
    """
    url = grailutil.extract_keyword("url", attrs, conv=string.strip)
    inline = attrs.has_key("inline")
    ps = self.formatter.writer.ps
    if url:
	url = self.context.get_baseurl(url)
	pageno, title = self.get_docinfo(url)
    else:
	pageno = ps.get_pageno()
    pageno = str(pageno)
    if inline:
	self.handle_data(pageno)
    else:
	self.formatter.softspace = 0
	numwidth = ps._font.text_width(pageno)
	pagewidth = ps.get_pagewidth()
	availwidth = pagewidth - ps._xpos
	if (availwidth - numwidth) < DOT_VACANCY:
	    ps.push_horiz_space(availwidth - numwidth)
	else:
	    dottedwidth = availwidth - DOT_VACANCY
	    leadingwidth = DOT_PITCH + dottedwidth % DOT_PITCH
	    numdots = int(dottedwidth / DOT_PITCH)
	    ps.push_horiz_space(leadingwidth)
	    ps._linefp.write(DOT_POSTSCRIPT * numdots)
	    ps.push_horiz_space(
		availwidth - (
		    leadingwidth + numwidth + (DOT_PITCH * numdots)))
	ps.push_string_flowing(pageno)


def postscript_start_h1(parser, attrs):
    """For H1 elements which have no ALIGN attribute, push to the outer edge
    of a duplexed page.

    For even-numbered pages, this adds ALIGN=LEFT, for odd-numbered pages,
    ALIGN=RIGHT.
    """
    align = grailutil.extract_keyword(
	'align', attrs, conv=grailutil.conv_normstring)
    if not align:
	if parser.formatter.writer.ps.get_pageno() & 1:
	    attrs['align'] = 'right'
	else:
	    attrs['align'] = 'left'
    parser.start_h1(attrs)

def postscript_end_h1(parser):
    parser.end_h1()

#
#  end of file
