import bookmarks
import dispatcher
import kptools
import test
import copy

import sys

# load the bookmarks
all = bookmarks.Bookmarks(file=sys.argv[1])
splits = dispatcher.dispatch(all, 0.0)
local = copy.deepcopy(all)
for entry in local.entries.values():
    entry['kss'] = 'local'

kps = splits
kps['local'] = local

launch = test.Launcher()
launch.go(kps)
for kss, log, bm in launch.results:
    if kss == 'local':
        temp = bm.entries
    print "%s\t%d\t%7.4f" % (kss, len(bm.entries), launch.times[kss])

cum = launch.times['isi'] + launch.times['cnri']
norm = launch.times['local']
print "speedup\t%7.4f" % (norm / cum)
print
hdr = 1
for url, entry in temp.items():
    if entry['last_visit'] == entry['last_modified']:
        if hdr:
            print "changed"
            hdr = 0
        print url
