import bookmarks
import test

def main(src, dest, logpath):
    b = bookmarks.Bookmarks(file=src)
    t = test.RandTester(b, logpath)
    for i in range(50):
        t.go()
    t.bm.dump(open(dest, 'w'))

if __name__ == "__main__":
    import sys
    import getopt
    opts, args = getopt.getopt(sys.argv[1:], 'l:')
    logpath = '.'
    for k, v in opts:
        if k == '-l':
            logpath = v
    [src, dest] = args
    main(src, dest, logpath)
