import time
import marshal

class KP:

    def __main__(self, kos):
        self.suitcase = kos.get_suitcase()
        http = self.load_http(kos)
        url = self.load_url()
        page = http.Get(url)
        s = time.time()
        page.open('r')
        html = page.read(-1)
        f = time.time()
        self.save(html, f - s)
        http.Close()

    def load_http(self, kos):
        factory = kos.lookup_service("HTTPAPI.Factory", "http").Open()
        return factory.GetHTTPRequester()

    def load_url(self):
        f = self.suitcase.open('url', 'r')
        url = f.read()
        f.close()
        return url

    def save(self, html, time):
        f = self.suitcase.open('results', 'w')
        s = marshal.dumps((html, time))
        f.write(s)
        f.close()


