"""Module for packing the suitcases of ImageRepo launched KPs.
"""

__version__ = '$Revision: 1.1 $'
# $Source: /projects/cvsroot/koe/src/demos/imagerepo/irkp_packer.py,v $

import Suitcase
import pickle

_ROTORSN = 8
_UPDATESN = 4
_DESTINATION = 'anthem'

def pack_suitcase(suitcasefs):
    # number of rotors
    fp = suitcasefs.open('rotorsn', 'w')
    pickle.dump(_ROTORSN, fp)
    fp.close()
    # number of `updates': md5hash(updates * key)
    fp = suitcasefs.open('updatesn', 'w')
    pickle.dump(_UPDATESN, fp)
    fp.close()
    # destination for migration
    fp = suitcasefs.open('destination', 'w')
    pickle.dump(_DESTINATION, fp)
    fp.close()
