"""Buyer part of buyer/seller example, showing trivial kp interaction."""

import sys
import nstools

class KP:
    def __main__(self, kos):
        print 'Buyer in...'
        self.kos = kos
        price = self.get_price("test_seller")
        if price != None:
            print "Buyer: got price", price
        else:
            print "Buyer: seller not found."
        sys.exit(0)
    def get_price(self, name):
        try:
            sellerdescr = self.kos.lookup_service("Seller1.Seller", name)
            seller = sellerdescr.Open()
        except nstools.BadPathError:
            return None
        else:
            return seller.price()

    def __getstate__(self):
        return {}
