(* the interface plugin collects interfaces available at other KOSes
   and keeps a list of them *)

INTERFACE InterfaceAPI;
(* INTERFACE InterfaceFinder IMPORTS KOSKernel END; *)

TYPE String = ilu.CString;
TYPE KOS = ilu.CString;
TYPE KOSes = SEQUENCE of KOS;
(* TYPE InterfaceType = KOSKernel.CnType; *)
TYPE InterfaceType = ilu.CString;
EXCEPTION UnknownInterface : String
	"There is no information about that interface";

TYPE InterfaceFinder = OBJECT
	METHODS
	Find( itype: InterfaceType ) : KOSes
		RAISES UnknownInterface END
	END;
