import sys
import KOS
import nstools

class KP:
    """Locate KOSes and send clones until we've really made a mess."""
    def __init__(self):
        self.all_done = 0

    def __main__(self, kos):
        this_kos = kos.get_kos_name()
        if self.all_done:
            sys.exit(this_kos)
        self.all_done = 1

        koslayer = nstools.WorldOpen('kos')
        names = koslayer.List()
        if this_kos in names:
            names.remove(this_kos)

        for name in names:
            try:
                kpid = kos.clone(name)
            except KOS.CommunicationError, msg:
                print "Can't talk to", name, "trying again"
            except KOS.NotFound, msg:
                print "Can't locate", name, "skipping"
            else:
                print 'Sent clone from %s to %s as %s.' \
                      % (this_kos, name, kpid)
