import sys
import time

class KP:

    def __main__(self, kos):
        FileIOError = kos.exception("FileAPI.FileIOError")
        printem = 1
        urls = sys.argv[1:]
        if urls and urls[0] == '-q':
            del urls[0]
            printem = 0
        if not urls:
            urls.append("http://www.cnri.reston.va.us")
        factory = kos.lookup_service("HTTPAPI.Factory", "http").Open()
        http = factory.GetHTTPRequester()
        for url in urls:
            print "Loading", url, "..."
            s = time.time()
            try:
                page = http.Get(url)
            except FileIOError, msg:
                print "Error:", msg
                continue
            page.open('r')
            html = page.read(-1)
            f = time.time()
            if printem:
                print html
            print "Opened and loaded in", round(f-s, 3), "seconds."
        http.Close()
