"""List all services at our KOS."""

import string

class KP:

    def __main__(self, kos):
        types = kos.list_service_types()
        print "Service types:"
        for type in types:
            print " ", type
        for type in types:
            print
            type_module = string.split(type, '.')[0]
            exceptions = kos.all_exceptions(type_module)
            list = dir(exceptions)
            list = filter(lambda x: x[:2]+x[-2:] != "____", list)
            if list:
                print "Exceptions defined module %s:" % type_module
                list.sort()
                for exc in list:
                    print " ", exc
            else:
                print "Module %s defines no exceptions" % type_module
            print "Services of type %s:" % str(type)
            for cname in kos.list_services(type):
                print "  name     =", `cname`
                cdescr = kos.lookup_service(type, cname)
                print "    Open() =", `cdescr.Open()`
