import KOS
import nstools

class KP:
    """Wander self.places until we've visited them all, or self.maxhops."""

    def __init__(self):
        self.maxhops = 20       #  *probably* hit all before we max out
        self.hopcount = 0
        self.been = {}
        print 'KP.__init__()'

    def __main__(self, kos):
        print 'KP.__main__(<%s>)' % kos.get_kos_name()

        self.been[kos.get_kos_name()] = 1
        self.hopcount = self.hopcount + 1

        kosnames = nstools.WorldOpen('kos').List()
        notbeen = []
        for name in kosnames:
            if not self.been.has_key(name):
                notbeen.append(name)

        if not notbeen:
            print "HOP", self.hopcount, "Been everywhere, i'm bored.  BYE."
            return

        if self.hopcount > self.maxhops:
                print "Hopped out, without visiting", notbeen
                return

        print "\tHOP", `self.hopcount`+";", 'AT:', kos.get_kos_name()
        for name in notbeen:
            print '\t  TO:', name
            try:
                kos.migrate(name)
            except KOS.CommunicationError, msg:
                print "\t    Can't talk to", name, "trying again"

        print "Could not locate reachable target."
