import ilu
import Stress
import traceback
import os, sys
import math

f = open('sbh')
sbh = f.read()
f.close()
server = ilu.ObjectOfSBH(Stress.Server, sbh)
pid = os.getpid()

f = open('%s.log' % pid, 'w')
def write(str, file=f):
    file.write(str + '\n')
    file.flush()
    print str

error = None
counter = 0
while 1:
    ping = server.IluPing()
    try:
        server.Pong()
        counter = counter + 1
        if error:
            write("%-8d %1d %5d SUCCESS" % (pid, ping, counter))
            print pid, ping, "SUCCESS"
            error = 0
        else:
            write("%-8d %1d %5d" % (pid, ping, counter))
    except ilu.IluProtocolError, err:
        retry = server.IluPing()
        write("%-8d %1d %1d %s" % (pid, ping, retry, err))
        error = 1
    except ilu.IluGeneralError, err:
        write("%-8d %1d EXIT %s" % (pid, ping, err))
        break
    except:
        write("%-8d EXIT" % pid)
        traceback.print_exc()
        break

    #could add some computation to the loop, but it seems to have little
    #effect
    #num = 881234567.
    #while num > 10.:
    #    num = math.sqrt(num) * 2

f.close()
