INTERFACE BitBucketAPI;

TYPE BinaryString = SEQUENCE of BYTE;
TYPE NameList = SEQUENCE of ilu.CString;

EXCEPTION BucketFull : ilu.CString;
EXCEPTION NotFound : ilu.CString;

TYPE BitBucket = OBJECT
	METHODS
	Set(name: ilu.CString, data: BinaryString)
	  RAISES BucketFull END,

	Get(name: ilu.CString): BinaryString
	  RAISES NotFound END,

	Delete(name: ilu.CString)
	  RAISES NotFound END,

	List(): NameList

	END;

		
	