import kpurllib
import kptools
import urllib
import bulk
import string
import time
import marshal
import operator
import sys


def main(kos, urls):
    kpurllib.set_kos(kos)
    for url in urls:
        print "TEST", url

        # do KP prefetch test
        b = time.time()
        urls, bytes, delta = kpurllib.prefetcht(url)
        e = time.time()
        print "KP prefetch", e - b, delta, bytes

        # do regular test
        delta, bytes = bulk.download(urls.keys())
        print "normal all ", delta, bytes

        # do KP get test
        b = time.time()
        html, delta = kpurllib.urlopent(url)
        e = time.time()
        print "KP get     ", e - b, delta, len(html)

        # do regular test
        delta, bytes = bulk.download([url])
        print "normal get ", delta, bytes

        print urls.keys()
        print
        sys.stdout.flush()

if __name__ == "__main__":
    import sys
    main(sys.argv[1], sys.argv[2:])
