"""Wrapper for the environment dictionary."""

__version__ = '$Revision: 1.2 $'


from koe.interfaces.stubs import Mapping
from koe.interfaces.stubs import Mapping__skel


class Environment(Mapping__skel.StringMap):
    def __init__(self, dict={}):
        self.__dict = {}
        self.__dict.update(dict)

    def GetKeys(self):
        return self.__dict.keys()

    def GetValue(self, key):
        try:
            return self.__dict[key]
        except KeyError:
            raise Mapping.KeyError, key

    def GetItems(self):
        return self.__dict.items()

    def SetValue(self, key, value):
        raise Mapping.WriteError, key

    def DeleteKey(self, key):
        raise Mapping.WriteError, key
