"""Seller part of buyer/seller example, showing trivial kp interaction."""


class KP:
    def __init__(self):
        print 'KP.__init__()'

    def __main__(self, kos):
        print 'KP.__main__()'
        self.service_id = kos.bind_service("test_seller", SellerImpl(7),
                                           "Seller1.Seller")
        kos.run()

    def __getstate__(self):
        return {}

class SellerImpl:
    """Start selling at "ante" (price to enter the game, as in poker), and
    up the price every time we're asked."""
    def __init__(self, ante=1):
        self.ante = ante
        print "Seller: starting price:", ante
    def price(self):
        self.ante = self.ante + 1
        print "Seller: quoting price:", self.ante
        return self.ante
