"""KOS plugin subprocess communications link with the KOS kernel."""

from koe.interfaces.stubs import KOSKernel__skel
from ProcessEntryImpl import ProcessEntry
    
class PluginEntry(KOSKernel__skel.PluginEntry, ProcessEntry):
    """KOS kernel communications link with an plugin subprocess."""

    proctype = "Plugin"

    def __init__(self, kernel, name=""):
        ProcessEntry.__init__(self, kernel)
        self.name = name
