(* Web content provider interface
 *
 * Provided as a service by KPs which provide live content to the web-server
 * bridge.
 *
 * This is very preliminary.
 *
 * $Revision: 1.3 $
 *)

INTERFACE ContentProviderAPI IMPORTS FileAPI, Mapping END;

TYPE String = ilu.CString;
TYPE Environment = Mapping.StringMap;


TYPE ContentProvider = OBJECT
    METHODS
	GetContent(url: String,
		   env: Environment,
		   fp: FileAPI.File)
	    "Perform an HTTP GET operation.  The return value is the HTTP
	     result code."
    END;
