"""Plugin to perform HTTP requests.

XXX There are several problems with this.  See child.py for details.

"""

# path hacking requires PYTHONPATH to be set
import sys
from koe.common import pluginlib
from koe.interfaces.stubs import HTTPAPI
import ilu


def main():
    kos, ns = pluginlib.register('http')
    serviceid = kos.bind_service('http', Factory(), 'HTTPAPI.Factory')
    try:
        kos.run()
    finally:
        kos.unbind_service(serviceid)


class Factory:
    
    def GetHTTPRequester(self):
        (sbh, pid, pids) = pluginlib.spawnserver("child.py")
        return ilu.ObjectOfSBH(HTTPAPI.Requester, sbh)


if __name__ == '__main__':
    main()
