"""The infamous "7 clones" benchmark.

Print a message and create two clones (on the same host).  Each clone
prints a message and generates two clones.  We could go on, but
actually we stop after the third generation, so we have generated 6
clones -- add the original, and we have 7 copies in total.

This used to take 28 seconds on an SGI Indigo2; last I looked
it took 6 seconds.  Talk about progress!

"""

# Limit number of generations -- set to 3 to create 2**3-1 copies
MAXGENERATION = 3

class KP:

    generation = 0

    def __main__(self, kos):
        self.generation = self.generation + 1
        print "\n\tHere is %s, generation %s\n" % (kos.get_kphandle(),
                                             self.generation)
        if self.generation < MAXGENERATION:
            kos.clone(kos.get_kos_name())
            kos.clone(kos.get_kos_name())
