#!/usr/bin/env python

# test the limit parser using the 'submit' group

import access
import pathhack

conf_file_name = pathhack.kos_root() + '/config/access.conf'
p = access.LimitParser(conf_file_name)
for host in ('knowbot','knowbot.cnri.reston.va.us'):
    if not p.is_allowed_from('submit', host,):
        print "Permission Denied from host: %s" % host
    else:
        print "Connections allowed from Host: %s" % host
    if not p.is_allowed_to('submit', host):
        print "Permission Denied to host: %s" % host
    else:
        print "Host: %s is allowed to submit" % host
