"""List the contents of the suitcase of this KP."""

import string

class KP:

    def __main__(self, kos):
        sfs = kos.get_suitcase()
        self.listdir(sfs, "/")

    def listdir(self, sfs, path):
        print sfs.path.join(path, '')
        names = sfs.listdir(path)
        names.sort()
        # XXX Remove duplicates reported by listdir bug
        for name in names[:]:
            if names.count(name) > 1:
                names.remove(name)
                continue
            fname = sfs.path.join(path, name)
            if sfs.path.isdir(fname):
                self.listdir(sfs, fname)
            else:
                self.listfile(sfs, fname)

    def listfile(self, sfs, path):
        print path,
        f = sfs.open(path)
        data = f.read()
        n = len(data)
        f.close()
        print " ", n, "bytes"
        if n and n < 80:
            r = `data`
            if len(r) <= 77:
                print " ", r
