"""Load the contents of the suitcase into a dictionary object.

Using the sctools module, this is trivial.

See also list-suitcase.py

Use the submit script to stuff arbitrary values in the suitcase.  For
instance:

submit -s foo:=bar -s spam:=ham load-suitcase.py
{'foo': 'bar', 'spam': 'ham'}

submit -s x/y:=1 -s x/z:=2 -s a/b:=yes load-suitcase.py
{'a': {'b': 'yes'}, 'x': {'y': '1', 'z': '2'}}

submit -s /:CVS load-suitcase.py
<<<This loads the entire contents of the CVS subdirectory>>>

"""

import sctools

class KP:

    def __main__(self, kos):
        dict = sctools.load_suitcase(kos)
        print dict
