"""Slightly more complex demonstration of a client.

See also server.py, client.py, and multiserver.py.

This demo builds on the example in client.py by listing all services
of the given object type and requesting each one's price.

"""

class KP:

    def __main__(self, kos):
        # kos.list_services() returns a list of namespace descriptiors
        sellers = kos.list_services("Seller1.Seller")
        if not sellers:
            print "No services were listed with type Seller1.Seller"
        for sellern in sellers:
            # Open a connector to the seller
            sellerd = kos.lookup_service("Seller1.Seller", sellern)
            seller = sellerd.Open()
            # Request and print the price
            price = seller.price()
            print "Seller", `sellern`, "quotes price", `price`
