"""Sleep for 30 seconds, then exit.

Add a suitcase file called `sleeptime' that contains an integer with
the number of seconds to sleep.

"""

import sys
import time
import string

class KP:
    def __main__(self, kos):
        sfs = kos.get_suitcase()
        try:
            fp = sfs.open('sleeptime', 'r')
            sleeptime = string.atoi(string.strip(fp.read()))
            fp.close()
        except (IOError, ValueError), msg:
            print "Could not open suitcase file: 'sleeptime', 'setting to 30"
            sleeptime = 30
        print 'going to sleep for %d seconds...' % sleeptime
        time.sleep(sleeptime)
        print 'ah! refreshed. bye!'
        sys.exit()
